from software.models import Software, SoftwareApproval
from software.serializers import SoftwareSerializer, SoftwareApprovalSerializer
from rest_framework import generics
from rest_framework.decorators import api_view
from rest_framework.response import Response
from rest_framework.parsers import JSONParser
from datetime import datetime


class SoftwareCreateRead(generics.ListCreateAPIView):
    queryset = Software.objects.all().order_by('id').reverse()
    serializer_class = SoftwareSerializer

    def perform_create(self, serializer):
        print("Software Version: "+ self.request.data["software_version"])
        print("EOS Maintenance: "+ self.request.data["eos_maintenance"])
        print("Last Date of Support: "+ self.request.data["last_date_of_support"])
        print("Technology: "+ self.request.data["technology"])
        print("Date Generated: "+ self.request.data["date_generated"])
        print("Generated by: "+ self.request.data["generated_by"])
        queryset = Software.objects.filter(
            software_version=self.request.data["software_version"])
        if queryset.exists():
            raise ValidationError('Duplicate Detected !!!')
        serializer.save()


class SoftwareUpdateDelete(generics.RetrieveUpdateDestroyAPIView):
    queryset = Software.objects.all()
    serializer_class = SoftwareSerializer


@api_view(['POST'])
def software_insert_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataSoftware"]
    for data in request_data:
        serializer = SoftwareSerializer(data=data)
        if serializer.is_valid():
            serializer.save()
    return Response(request_data)


@api_view(['POST'])
def software_update_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataSoftware"]
    # print(datetime.today().strftime('%Y-%m-%d %H:%M:%S'))
    for data in request_data:
        log = Software.objects.filter(
            id=data["approval_id"]).update(software_version=data["software_version"],
                                           eos_maintenance=data["eos_maintenance"],
                                           last_date_of_support=data["last_date_of_support"],
                                           technology=data["technology"],
                                           date_generated=["date_generated"],
                                           generated_by=data["generated_by"])

    return Response(request_data)


@api_view(['POST'])
def software_delete_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataSoftware"]
    for data in request_data:
        software = Software.objects.get(id=data["id"])
        software.delete()
    # print(request_data)
    return Response(request_data)


class SoftwareApprovalCreateRead(generics.ListCreateAPIView):
    querysetOri = Software.objects.all().order_by('id').reverse()
    queryset = SoftwareApproval.objects.all().order_by('id').reverse()
    serializer_class = SoftwareApprovalSerializer

    def perform_create(self, serializer):
        querysetOri = Software.objects.filter(
            software_version=self.request.data["software_version"])
        if querysetOri.exists():
            raise ValidationError('Duplicate Detected !!!')

        # print(self.request.data["software_version"])
        queryset = SoftwareApproval.objects.filter(
            software_version=self.request.data["software_version"])
        if queryset.exists():
            raise ValidationError('Duplicate Detected !!!')

        serializer.save()


@api_view(['POST'])
def software_approval_member(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["username"]
    queryset = SoftwareApproval.objects.all().filter(generated_by=request_data)
    serializer_class = SoftwareApprovalSerializer(queryset, many=True)
    return Response(serializer_class.data)


class SoftwareApprovalUpdateDelete(generics.RetrieveUpdateDestroyAPIView):
    queryset = SoftwareApproval.objects.all()
    serializer_class = SoftwareApprovalSerializer


@api_view(['POST'])
def software_approval_delete_selected(request):
    request_data = JSONParser().parse(request)
    request_data = request_data["dataSoftware"]
    for data in request_data:
        software_approval = SoftwareApproval.objects.get(id=data["id"])
        software_approval.delete()
    # print(request_data)
    return Response(request_data)
